/**
 * Copyright (c) 2016-2018 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see http://www.gnu.org/licenses/
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.microkernel.api.container;

import java.util.concurrent.Callable;

import javax.jbi.JBIException;

/**
 * A way for implementations of lifecycles to execute tasks in an ordered way on the component.
 * 
 * @author vnoel
 *
 */
public interface IsolatingThread {

    /**
     * Execute the callable with ccl as the context classloader.
     * 
     * Callable are meant to only throw {@link JBIException}!
     */
    public <T> T execute(final Callable<T> what, final ClassLoader ccl) throws JBIException;
}
