/**
 * Copyright (c) 2013-2018 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see http://www.gnu.org/licenses/
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.microkernel.api.extension;


/**
 * <p>
 * Controller of a post-extension.
 * </p>
 * 
 * @author Christophe DENEUX - Linagora
 * 
 */
public interface PetalsPostExtensionController extends PetalsExtensionController {

    /**
     * The name of the server interface to provide {@link InstallationExtension}.
     */
    public final static String INST_EXT_SRV_ITF_NAME = "installationExtension";

    /**
     * 
     * For this to work, the Fractal component must provides a port named {@value #INST_EXT_SRV_ITF_NAME} and of type
     * {@link InstallationExtension}.
     * 
     * @return <code>true</code> if the extension must be notified of artifacts installations.
     */
    boolean isInstallationExtension();

}
